• <ins id="pjuwb"></ins>
    <blockquote id="pjuwb"><pre id="pjuwb"></pre></blockquote>
    <noscript id="pjuwb"></noscript>
          <sup id="pjuwb"><pre id="pjuwb"></pre></sup>
            <dd id="pjuwb"></dd>
            <abbr id="pjuwb"></abbr>

            eryar

            PipeCAD - Plant Piping Design Software.
            RvmTranslator - Translate AVEVA RVM to OBJ, glTF, etc.
            posts - 603, comments - 590, trackbacks - 0, articles - 0

            Split Shape by Plane in OpenCASCADE

            Posted on 2017-07-01 12:21 eryar 閱讀(3956) 評論(0)  編輯 收藏 引用 所屬分類: 2.OpenCASCADE

            Split Shape by Plane in OpenCASCADE

            eryar@163.com

            Abstract. Sometimes you want to split a shape by plane or even split a shape by a B Spline surface, OpenCASCADE provide a feature class BRepFeat_SplitShape to implement the function. The paper give a sample code to split a cylinder by plane.

            Key Words. Split Shape, BRep Feature Algorithms.

            1. Introduction

            OpenCASCADE提供了Boolean Operation實現了任意兩個形狀的交、并、差的布爾操作。但是如何實現用一個面將一個形狀切割成兩半呢?其實Boolean Operation中已經有求交分割的算法,但是沒有直接提供一個分割的功能類,而是在BRepFeat_SplitShape提供了分割功能。

            wps69BE.tmp

            Figure 1. Split Cylinder by Plane

            2. Code Demo

            使用類BRepAlgoAPI_Section和類BRepFeat_SplitShape相結合來實現分割Split形狀的功能。完整代碼示例如下:

            /*
            Copyright(C) 2017 Shing Liu(eryar@163.com)

            Permission is hereby granted, free of charge, to any person obtaining a copy
            of this software and associated documentation files(the "Software"), to deal
            in the Software without restriction, including without limitation the rights
            to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
            copies of the Software, and to permit persons to whom the Software is
            furnished to do so, subject to the following conditions :

            The above copyright notice and this permission notice shall be included in all
            copies or substantial portions of the Software.

            THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
            IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
            FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.IN NO EVENT SHALL THE
            AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
            LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
            OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
            SOFTWARE.
            */

            // Visual Studio 2013 & OpenCASCADE7.1.0

            #include <gp_Pln.hxx>

            #include <TopoDS.hxx>

            #include <TopExp.hxx>
            #include <TopExp_Explorer.hxx>

            #include <BRepTools.hxx>

            #include <BRepPrimAPI_MakeCylinder.hxx>

            #include <BRepAlgoAPI_Section.hxx>

            #include <BRepFeat_SplitShape.hxx>

            #pragma comment(lib, "TKernel.lib")
            #pragma comment(lib, "TKMath.lib")

            #pragma comment(lib, "TKG2d.lib")
            #pragma comment(lib, "TKG3d.lib")
            #pragma comment(lib, "TKGeomBase.lib")
            #pragma comment(lib, "TKGeomAlgo.lib")

            #pragma comment(lib, "TKBRep.lib")
            #pragma comment(lib, "TKTopAlgo.lib")

            #pragma comment(lib, "TKBO.lib")
            #pragma comment(lib, "TKPrim.lib")
            #pragma comment(lib, "TKFeat.lib")

            //! Test split a cylinder by plane.
            //! You can use the algorithm to split other shapes.
            void testSplit()
            {
                BRepPrimAPI_MakeCylinder aCylinderMaker(10.0, 20.0);
                TopoDS_Shape aCylinder = aCylinderMaker.Shape();

                // Build section by the split plane for the cylinder.
                BRepAlgoAPI_Section aSection(aCylinder, gp_Pln(gp_Pnt(0.0, 0.0, 15.0), gp::DZ()), Standard_False);
                aSection.ComputePCurveOn1(Standard_True);
                aSection.Approximation(Standard_True);
                aSection.Build();

                // Split the cylinder shape.
                BRepFeat_SplitShape aShapeSpliter(aCylinder);

                for (TopExp_Explorer i(aSection.Shape(), TopAbs_EDGE); i.More(); i.Next())
                {
                    TopoDS_Shape anEdge = i.Current();
                    TopoDS_Shape aFace;

                    if (aSection.HasAncestorFaceOn1(anEdge, aFace))
                    {
                        TopoDS_Edge E = TopoDS::Edge(anEdge);
                        TopoDS_Face F = TopoDS::Face(aFace);

                        aShapeSpliter.Add(E, F);
                    }
                }

                aShapeSpliter.Build();

                // Rebuild left and right shape.
                BRep_Builder aBuilder;
                TopoDS_Compound aLeftCompound;
                TopoDS_Compound aRightCompound;

                aBuilder.MakeCompound(aLeftCompound);
                aBuilder.MakeCompound(aRightCompound);

                // Left shape.
                TopTools_MapOfShape aLeftShapeMap;
                const TopTools_ListOfShape& aLeftShapes = aShapeSpliter.Left();
                for (auto i = aLeftShapes.cbegin(); i != aLeftShapes.cend(); i++)
                {
                    aLeftShapeMap.Add(*i);

                    aBuilder.Add(aLeftCompound, *i);
                }

                // Right shape.
                TopTools_IndexedMapOfShape aShapeMap;
                TopExp::MapShapes(aShapeSpliter.Shape(), TopAbs_FACE, aShapeMap);

                for (auto i = aShapeMap.cbegin(); i != aShapeMap.cend(); i++)
                {
                    if (!aLeftShapeMap.Contains(*i))
                    {
                        aBuilder.Add(aRightCompound, *i);
                    }
                }

                // Output left and right shape.
                BRepTools::Write(aLeftCompound, "d:/left.brep");
                BRepTools::Write(aRightCompound, "d:/right.brep");
            }

            int main(int argc, char* argv[])
            {
                testSplit();

                return 0;
            }

            先創建一個圓柱體,再使用類BRepAlgoAPI_Section將圓柱體用平面進行分割,最后使用類BRepFeat_SplitShape進行分類,得到切割后的形狀及Left()形狀,把切割后形狀中的Left過濾后剩下就是切割另一半的形狀;最后導出被平面切割后得到的兩半形狀。結果用動畫演示如下:

            split shape

            Figure 2. Split Shape animation demo

            3. Conclusion

            OpenCASCADE提供類BRepFeat_SplitShape來實現對一個形狀進行切割的功能,但是要配合BRepAlgoAPI_Section使用。因為Boolean Operation中已經實現了求交、分類的功能,所以在最新版本的源碼7.2.0中已經將分割功能集成到了Boolean Operation中。分割后如果沒有被改變的面還是原來的面。

            .精品久久久麻豆国产精品| 精品久久久久久无码免费| 久久久久久无码国产精品中文字幕| 99久久这里只有精品| 97精品伊人久久大香线蕉app| 九九久久99综合一区二区| 青青青青久久精品国产| 久久精品国产99久久久香蕉| 久久久受www免费人成| 国产亚洲美女精品久久久2020| 久久久一本精品99久久精品66| 久久精品国产亚洲av水果派| 久久亚洲精品中文字幕三区| 久久综合精品国产一区二区三区| 亚洲中文久久精品无码| 九九久久99综合一区二区| 人妻精品久久久久中文字幕| 久久精品国产99久久久古代 | 亚洲AV无码久久精品狠狠爱浪潮| 97久久超碰国产精品2021| 久久91这里精品国产2020| 亚洲va中文字幕无码久久不卡 | 99久久99久久精品国产片果冻| 久久精品综合一区二区三区| 中文精品久久久久人妻不卡| 国产99久久九九精品无码| 久久天天躁狠狠躁夜夜网站 | 久久久久波多野结衣高潮| 国内精品久久人妻互换| 色综合久久天天综线观看| 久久久噜噜噜久久熟女AA片| 久久露脸国产精品| 久久精品夜夜夜夜夜久久| 亚洲国产成人久久综合野外| 9999国产精品欧美久久久久久| 久久久亚洲欧洲日产国码是AV| 99久久国产亚洲高清观看2024| 久久精品天天中文字幕人妻| 亚洲中文字幕无码一久久区| 伊人 久久 精品| 性做久久久久久久久|